Subject: Re: [PATCH net-next 1/9] net: benet: convert to use .get_rx_ring_count

From: Jakub Kicinski <[email-masked]>
Date: Mon, 19 Jan 2026 09:45:14 -0800

On Mon, 19 Jan 2026 04:56:49 -0800 Breno Leitao wrote:
> > > I think we need to add this check to set_rxfh now. The error coming
> > > from get_rxnfc/GRXRINGS effectively shielded the driver from set_rxfh
> > > calls ever happening when there's only 1 ring. Now they will happen.  
> > 
> > You are absolutely correct. The ethtool core calls
> > get_rxnfc(ETHTOOL_GRXRINGS) _before_ allowing RSS configuration via
> > set_rxfh, and if it fails, ethtool_set_rxfh() will fail as well. And
> > with the current change, ethtool_set_rxfh() will not fail if the adapter
> > is not multi-queue.  
> 
> Upon further consideration, should we implement this limitation directly within
> the ethtool infrastructure?

That may cause some regressions, we're getting the number of currently
configured Rx rings. If we were to check how many Rx rings the device
has that'd make sense. But since we can only access currently
configured rings, in theory, if the device has multiple rings,
just only one is active now - changing config for the RSS key or
function should work just fine. IOW

 # change key
 # increase ring count to make they key meaningful

Used to work.